/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.extension_mechanisms.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Constraint;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.GeneralizableElementImpl;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.TaggedValue;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Stereotype</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.impl.StereotypeImpl#getIcon <em>Icon</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.impl.StereotypeImpl#getBaseClass <em>Base Class</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.impl.StereotypeImpl#getRequiredTag <em>Required Tag</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.impl.StereotypeImpl#getExtendedElement <em>Extended Element</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.impl.StereotypeImpl#getStereotypeConstraint <em>Stereotype Constraint</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class StereotypeImpl extends GeneralizableElementImpl implements Stereotype {
	/**
	 * The default value of the '{@link #getIcon() <em>Icon</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIcon()
	 * @generated
	 * @ordered
	 */
	protected static final String ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getIcon() <em>Icon</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getIcon()
	 * @generated
	 * @ordered
	 */
	protected String icon = ICON_EDEFAULT;

	/**
	 * The default value of the '{@link #getBaseClass() <em>Base Class</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBaseClass()
	 * @generated
	 * @ordered
	 */
	protected static final String BASE_CLASS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBaseClass() <em>Base Class</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBaseClass()
	 * @generated
	 * @ordered
	 */
	protected String baseClass = BASE_CLASS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getRequiredTag() <em>Required Tag</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getRequiredTag()
	 * @generated
	 * @ordered
	 */
	protected EList requiredTag = null;

	/**
	 * The cached value of the '{@link #getExtendedElement() <em>Extended Element</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getExtendedElement()
	 * @generated
	 * @ordered
	 */
	protected EList extendedElement = null;

	/**
	 * The cached value of the '{@link #getStereotypeConstraint() <em>Stereotype Constraint</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStereotypeConstraint()
	 * @generated
	 * @ordered
	 */
	protected EList stereotypeConstraint = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected StereotypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Extension_mechanismsPackage.eINSTANCE.getStereotype();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getIcon() {
		return icon;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIcon(String newIcon) {
		String oldIcon = icon;
		icon = newIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Extension_mechanismsPackage.STEREOTYPE__ICON, oldIcon, icon));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getBaseClass() {
		return baseClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setBaseClass(String newBaseClass) {
		String oldBaseClass = baseClass;
		baseClass = newBaseClass;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Extension_mechanismsPackage.STEREOTYPE__BASE_CLASS, oldBaseClass, baseClass));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getRequiredTag() {
		if (requiredTag == null) {
			requiredTag = new EObjectContainmentWithInverseEList(TaggedValue.class, this, Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG, Extension_mechanismsPackage.TAGGED_VALUE__STEREOTYPE);
		}
		return requiredTag;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getExtendedElement() {
		if (extendedElement == null) {
			extendedElement = new EObjectWithInverseResolvingEList(ModelElement.class, this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, CorePackage.MODEL_ELEMENT__STEREOTYPE);
		}
		return extendedElement;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStereotypeConstraint() {
		if (stereotypeConstraint == null) {
			stereotypeConstraint = new EObjectContainmentWithInverseEList(Constraint.class, this, Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT,
					CorePackage.CONSTRAINT__CONSTRAINED_ELEMENT2);
		}
		return stereotypeConstraint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Extension_mechanismsPackage.STEREOTYPE__NAMESPACE, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG:
				return ((InternalEList) getRequiredTag()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT:
				return ((InternalEList) getExtendedElement()).basicAdd(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT:
				return ((InternalEList) getStereotypeConstraint()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
				return eBasicSetContainer(null, Extension_mechanismsPackage.STEREOTYPE__NAMESPACE, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__BINDING:
				return basicSetBinding(null, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG:
				return ((InternalEList) getRequiredTag()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT:
				return ((InternalEList) getExtendedElement()).basicRemove(otherEnd, msgs);
			case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT:
				return ((InternalEList) getStereotypeConstraint()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_IMPORT:
			return getElementImport();
		case Extension_mechanismsPackage.STEREOTYPE__NAME:
			return getName();
		case Extension_mechanismsPackage.STEREOTYPE__VISIBILITY:
			return getVisibility();
		case Extension_mechanismsPackage.STEREOTYPE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
			return getNamespace();
		case Extension_mechanismsPackage.STEREOTYPE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Extension_mechanismsPackage.STEREOTYPE__CONSTRAINT:
			return getConstraint();
		case Extension_mechanismsPackage.STEREOTYPE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Extension_mechanismsPackage.STEREOTYPE__PRESENTATION:
			return getPresentation();
		case Extension_mechanismsPackage.STEREOTYPE__TARGET_FLOW:
			return getTargetFlow();
		case Extension_mechanismsPackage.STEREOTYPE__SOURCE_FLOW:
			return getSourceFlow();
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Extension_mechanismsPackage.STEREOTYPE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Extension_mechanismsPackage.STEREOTYPE__COMMENT:
			return getComment();
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Extension_mechanismsPackage.STEREOTYPE__TAGGED_VALUE:
			return getTaggedValue();
		case Extension_mechanismsPackage.STEREOTYPE__BEHAVIOR:
			return getBehavior();
		case Extension_mechanismsPackage.STEREOTYPE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Extension_mechanismsPackage.STEREOTYPE__COLLABORATION:
			return getCollaboration();
		case Extension_mechanismsPackage.STEREOTYPE__PARTITION:
			return getPartition();
		case Extension_mechanismsPackage.STEREOTYPE__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case Extension_mechanismsPackage.STEREOTYPE__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case Extension_mechanismsPackage.STEREOTYPE__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case Extension_mechanismsPackage.STEREOTYPE__GENERALIZATION:
			return getGeneralization();
		case Extension_mechanismsPackage.STEREOTYPE__SPECIALIZATION:
			return getSpecialization();
		case Extension_mechanismsPackage.STEREOTYPE__ICON:
			return getIcon();
		case Extension_mechanismsPackage.STEREOTYPE__BASE_CLASS:
			return getBaseClass();
		case Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG:
			return getRequiredTag();
		case Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT:
			return getExtendedElement();
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT:
			return getStereotypeConstraint();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__NAME:
			setName((String) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__BINDING:
			setBinding((Binding) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case Extension_mechanismsPackage.STEREOTYPE__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__ICON:
			setIcon((String) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__BASE_CLASS:
			setBaseClass((String) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG:
			getRequiredTag().clear();
			getRequiredTag().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT:
			getExtendedElement().clear();
			getExtendedElement().addAll((Collection) newValue);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT:
			getStereotypeConstraint().clear();
			getStereotypeConstraint().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__CONSTRAINT:
			getConstraint().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__PRESENTATION:
			getPresentation().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__BINDING:
			setBinding((Binding) null);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__COMMENT:
			getComment().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__BEHAVIOR:
			getBehavior().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__COLLABORATION:
			getCollaboration().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__PARTITION:
			getPartition().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__GENERALIZATION:
			getGeneralization().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__ICON:
			setIcon(ICON_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__BASE_CLASS:
			setBaseClass(BASE_CLASS_EDEFAULT);
			return;
		case Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG:
			getRequiredTag().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT:
			getExtendedElement().clear();
			return;
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT:
			getStereotypeConstraint().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Extension_mechanismsPackage.STEREOTYPE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Extension_mechanismsPackage.STEREOTYPE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Extension_mechanismsPackage.STEREOTYPE__NAMESPACE:
			return getNamespace() != null;
		case Extension_mechanismsPackage.STEREOTYPE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__BINDING:
			return binding != null;
		case Extension_mechanismsPackage.STEREOTYPE__COMMENT:
			return comment != null && !comment.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE:
			return stereotype != null;
		case Extension_mechanismsPackage.STEREOTYPE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__PARTITION:
			return partition != null && !partition.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case Extension_mechanismsPackage.STEREOTYPE__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case Extension_mechanismsPackage.STEREOTYPE__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case Extension_mechanismsPackage.STEREOTYPE__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__ICON:
			return ICON_EDEFAULT == null ? icon != null : !ICON_EDEFAULT.equals(icon);
		case Extension_mechanismsPackage.STEREOTYPE__BASE_CLASS:
			return BASE_CLASS_EDEFAULT == null ? baseClass != null : !BASE_CLASS_EDEFAULT.equals(baseClass);
		case Extension_mechanismsPackage.STEREOTYPE__REQUIRED_TAG:
			return requiredTag != null && !requiredTag.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT:
			return extendedElement != null && !extendedElement.isEmpty();
		case Extension_mechanismsPackage.STEREOTYPE__STEREOTYPE_CONSTRAINT:
			return stereotypeConstraint != null && !stereotypeConstraint.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (icon: "); //$NON-NLS-1$
		result.append(icon);
		result.append(", baseClass: "); //$NON-NLS-1$
		result.append(baseClass);
		result.append(')');
		return result.toString();
	}

} // StereotypeImpl
