/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.AssociationEndRole;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.foundation.core.Association;
import fr.obeo.acceleo.uml14.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml14.foundation.core.Attribute;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.AssociationEndImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.AggregationKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ChangeableKind;
import fr.obeo.acceleo.uml14.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml14.foundation.data_types.OrderingKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ScopeKind;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Association End Role</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.AssociationEndRoleImpl#getCollaborationMultiplicity <em>Collaboration Multiplicity</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.AssociationEndRoleImpl#getBase <em>Base</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.AssociationEndRoleImpl#getAvailableQualifier <em>Available Qualifier</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class AssociationEndRoleImpl extends AssociationEndImpl implements AssociationEndRole {
	/**
	 * The cached value of the '{@link #getCollaborationMultiplicity() <em>Collaboration Multiplicity</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCollaborationMultiplicity()
	 * @generated
	 * @ordered
	 */
	protected Multiplicity collaborationMultiplicity = null;

	/**
	 * The cached value of the '{@link #getBase() <em>Base</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBase()
	 * @generated
	 * @ordered
	 */
	protected AssociationEnd base = null;

	/**
	 * The cached value of the '{@link #getAvailableQualifier() <em>Available Qualifier</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAvailableQualifier()
	 * @generated
	 * @ordered
	 */
	protected EList availableQualifier = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AssociationEndRoleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getAssociationEndRole();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Multiplicity getCollaborationMultiplicity() {
		return collaborationMultiplicity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetCollaborationMultiplicity(Multiplicity newCollaborationMultiplicity, NotificationChain msgs) {
		Multiplicity oldCollaborationMultiplicity = collaborationMultiplicity;
		collaborationMultiplicity = newCollaborationMultiplicity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY, oldCollaborationMultiplicity,
					newCollaborationMultiplicity);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setCollaborationMultiplicity(Multiplicity newCollaborationMultiplicity) {
		if (newCollaborationMultiplicity != collaborationMultiplicity) {
			NotificationChain msgs = null;
			if (collaborationMultiplicity != null)
				msgs = ((InternalEObject) collaborationMultiplicity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY, null, msgs);
			if (newCollaborationMultiplicity != null)
				msgs = ((InternalEObject) newCollaborationMultiplicity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY, null, msgs);
			msgs = basicSetCollaborationMultiplicity(newCollaborationMultiplicity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY, newCollaborationMultiplicity, newCollaborationMultiplicity));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationEnd getBase() {
		if (base != null && base.eIsProxy()) {
			AssociationEnd oldBase = base;
			base = (AssociationEnd) eResolveProxy((InternalEObject) base);
			if (base != oldBase) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CollaborationsPackage.ASSOCIATION_END_ROLE__BASE, oldBase, base));
			}
		}
		return base;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationEnd basicGetBase() {
		return base;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetBase(AssociationEnd newBase, NotificationChain msgs) {
		AssociationEnd oldBase = base;
		base = newBase;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.ASSOCIATION_END_ROLE__BASE, oldBase, newBase);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setBase(AssociationEnd newBase) {
		if (newBase != base) {
			NotificationChain msgs = null;
			if (base != null)
				msgs = ((InternalEObject) base).eInverseRemove(this, CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE, AssociationEnd.class, msgs);
			if (newBase != null)
				msgs = ((InternalEObject) newBase).eInverseAdd(this, CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE, AssociationEnd.class, msgs);
			msgs = basicSetBase(newBase, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.ASSOCIATION_END_ROLE__BASE, newBase, newBase));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAvailableQualifier() {
		if (availableQualifier == null) {
			availableQualifier = new EObjectWithInverseResolvingEList.ManyInverse(Attribute.class, this, CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER,
					CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE);
		}
		return availableQualifier;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__QUALIFIER:
				return ((InternalEList) getQualifier()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTICIPANT:
				if (participant != null)
					msgs = ((InternalEObject) participant).eInverseRemove(this, CorePackage.CLASSIFIER__ASSOCIATION, Classifier.class, msgs);
				return basicSetParticipant((Classifier) otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__SPECIFICATION:
				return ((InternalEList) getSpecification()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__LINK_END:
				return ((InternalEList) getLinkEnd()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION_END_ROLE:
				return ((InternalEList) getAssociationEndRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__BASE:
				if (base != null)
					msgs = ((InternalEObject) base).eInverseRemove(this, CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE, AssociationEnd.class, msgs);
				return basicSetBase((AssociationEnd) otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER:
				return ((InternalEList) getAvailableQualifier()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__MULTIPLICITY:
				return basicSetMultiplicity(null, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
				return eBasicSetContainer(null, CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__QUALIFIER:
				return ((InternalEList) getQualifier()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTICIPANT:
				return basicSetParticipant(null, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__SPECIFICATION:
				return ((InternalEList) getSpecification()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__LINK_END:
				return ((InternalEList) getLinkEnd()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION_END_ROLE:
				return ((InternalEList) getAssociationEndRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY:
				return basicSetCollaborationMultiplicity(null, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__BASE:
				return basicSetBase(null, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER:
				return ((InternalEList) getAvailableQualifier()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
				return eContainer.eInverseRemove(this, CorePackage.ASSOCIATION__CONNECTION, Association.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAME:
			return getName();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COMMENT:
			return getComment();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__STEREOTYPE:
			return getStereotype();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__REFERENCE_TAG:
			return getReferenceTag();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTITION:
			return getPartition();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_NAVIGABLE:
			return isIsNavigable() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ORDERING:
			return getOrdering();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AGGREGATION:
			return getAggregation();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_SCOPE:
			return getTargetScope();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__MULTIPLICITY:
			return getMultiplicity();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CHANGEABILITY:
			return getChangeability();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
			return getAssociation();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__QUALIFIER:
			return getQualifier();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTICIPANT:
			if (resolve)
				return getParticipant();
			return basicGetParticipant();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SPECIFICATION:
			return getSpecification();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__LINK_END:
			return getLinkEnd();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION_END_ROLE:
			return getAssociationEndRole();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY:
			return getCollaborationMultiplicity();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BASE:
			if (resolve)
				return getBase();
			return basicGetBase();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER:
			return getAvailableQualifier();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_NAVIGABLE:
			setIsNavigable(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ORDERING:
			setOrdering((OrderingKind) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AGGREGATION:
			setAggregation((AggregationKind) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_SCOPE:
			setTargetScope((ScopeKind) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__MULTIPLICITY:
			setMultiplicity((Multiplicity) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CHANGEABILITY:
			setChangeability((ChangeableKind) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
			setAssociation((Association) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__QUALIFIER:
			getQualifier().clear();
			getQualifier().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTICIPANT:
			setParticipant((Classifier) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SPECIFICATION:
			getSpecification().clear();
			getSpecification().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__LINK_END:
			getLinkEnd().clear();
			getLinkEnd().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION_END_ROLE:
			getAssociationEndRole().clear();
			getAssociationEndRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY:
			setCollaborationMultiplicity((Multiplicity) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BASE:
			setBase((AssociationEnd) newValue);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER:
			getAvailableQualifier().clear();
			getAvailableQualifier().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__STEREOTYPE:
			getStereotype().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_NAVIGABLE:
			setIsNavigable(IS_NAVIGABLE_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ORDERING:
			setOrdering(ORDERING_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AGGREGATION:
			setAggregation(AGGREGATION_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_SCOPE:
			setTargetScope(TARGET_SCOPE_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__MULTIPLICITY:
			setMultiplicity((Multiplicity) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CHANGEABILITY:
			setChangeability(CHANGEABILITY_EDEFAULT);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
			setAssociation((Association) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__QUALIFIER:
			getQualifier().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTICIPANT:
			setParticipant((Classifier) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SPECIFICATION:
			getSpecification().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__LINK_END:
			getLinkEnd().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION_END_ROLE:
			getAssociationEndRole().clear();
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY:
			setCollaborationMultiplicity((Multiplicity) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BASE:
			setBase((AssociationEnd) null);
			return;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER:
			getAvailableQualifier().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.ASSOCIATION_END_ROLE__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__IS_NAVIGABLE:
			return isNavigable != IS_NAVIGABLE_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ORDERING:
			return ordering != ORDERING_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AGGREGATION:
			return aggregation != AGGREGATION_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__TARGET_SCOPE:
			return targetScope != TARGET_SCOPE_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__MULTIPLICITY:
			return multiplicity != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__CHANGEABILITY:
			return changeability != CHANGEABILITY_EDEFAULT;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION:
			return getAssociation() != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__QUALIFIER:
			return qualifier != null && !qualifier.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__PARTICIPANT:
			return participant != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__SPECIFICATION:
			return specification != null && !specification.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__LINK_END:
			return linkEnd != null && !linkEnd.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__ASSOCIATION_END_ROLE:
			return associationEndRole != null && !associationEndRole.isEmpty();
		case CollaborationsPackage.ASSOCIATION_END_ROLE__COLLABORATION_MULTIPLICITY:
			return collaborationMultiplicity != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__BASE:
			return base != null;
		case CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER:
			return availableQualifier != null && !availableQualifier.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // AssociationEndRoleImpl
